#!/usr/bin/perl -w
$LSPCI = `which lspci`;
chomp($LSPCI);
$LSPCI = "$LSPCI -nv";
@LSPCI_OUT = `$LSPCI`;

$ttynum = $ARGV[0];

$linecount = @LSPCI_OUT;
@setserial_cmds = ();
$setserial_cmd_count = 0;

ENTRY: for ($linenum = 0 ; $linenum < $linecount ; $linenum = $linenum + 1) {
	if ($LSPCI_OUT[$linenum] =~ /135e:7(.)../) {
		@ioports = ();
		$numports = $1;
		$ioportcount = 0;
		$linenum = $linenum + 1;
		RESOURCE: for (; $linenum < $linecount ; $linenum = $linenum + 1) {
			if ($LSPCI_OUT[$linenum] =~ /IRQ (\d{1,2})/) {
				$irq = $1;
			}
			if ($LSPCI_OUT[$linenum] =~ /ports at (....)/) {
				$ioports[$ioportcount] = $1;
				$ioportcount += 1;
			}
			if ($LSPCI_OUT[$linenum] =~ /Class/) {
				for ($portnum = 0; $portnum < $numports; $portnum = $portnum + 1) {
					if ($numports != 8) {
						$portaddress = $ioports[($portnum + 1)];
					} else {
						$temp = hex($ioports[1]) + 8 * $portnum;
						$portaddress = sprintf "%lx", $temp;
					}
					$setserial_cmds[$setserial_cmd_count] = "setserial /dev/ttyS$ttynum port 0x$portaddress irq $irq ^fourport autoconfig";
					$setserial_cmd_count = $setserial_cmd_count + 1;
					$ttynum = $ttynum + 1;
				}
				if ($numports > 1) {
					$baseport = $ttynum - $numports;
					$iostat = hex($ioports[1]) + 7;
					$hexiostat = sprintf("%lx",$iostat);
					if ($numports == 2) {
						$mask = "3";
					} 
					if ($numports == 4) {
						$mask = "f";
					} else  {
						$mask = "ff";
					}
					$setserial_cmds[$setserial_cmd_count] = "setserial /dev/ttyS$baseport set_multiport port1 0x$hexiostat mask1 0x$mask match1 0x0";
					$setserial_cmd_count = $setserial_cmd_count + 1;
				}
				next ENTRY;
			}
		}
	}
}

foreach (@setserial_cmds) {
	print;
	print "\n";
	system($_);
}
